<?php


    $Error_msg;

    function error_close()
        {
            global $Error_msg;

            $err_msg = "Error occured at mail server. Mail was not sent!";

            $_ = func_get_args();

            $Error_msg = $err_msg;
            $ec_pktLen = strlen('QUIT\n');
            $ec_bytes_wrttn = 0;
            while (($ec_pktLen - $ec_bytes_wrttn) > 0)
                {
                    $ec_balance = $ec_pktLen - $ec_bytes_wrttn;
                    $remaining_ec = substr('QUIT\n', $ec_bytes_wrttn, $ec_balance);
                    $bufLendec = strlen($remaining_ec);  
                    $ec_bytes_wrttnNew = socket_write($_[0], $remaining_ec, $bufLendec); 
                    if ($ec_bytes_wrttn === false)
                        {
                            $Error_msg .= socket_strerror(socket_last_error($_[0]));
                            return false;
                        }
                    $ec_bytes_wrttn = $ec_bytes_wrttn + $ec_bytes_wrttnNew;
                }
        }
        
    function sendmail($arr)
        {
            global $Error_msg;

            $err_msg = "Error occured at mail server. Mail was not sent!";

            $remote_host = $arr['remote_host'];
            $remote_host = "" . $remote_host . "";
            $remote_host = preg_replace('/^\s*|\s*$/', '', $remote_host);
            if (!((preg_match("/([0-9a-zA-Z_\-]{1,64}\.)?[0-9a-zA-Z_\-]{1,64}(\.[0-9a-zA-Z_\-]{2,4}){0,2}(:[0-9]{1,5})?(\/[0-9a-zA-Z_\-]{1,64}){0,64}([0-9a-zA-Z_\-]{1,64}(\.[a-zA-Z]{1,4})?)?/", $remote_host))||(preg_match("/:+:+:/", $remote_host))))
                {
                    $Error_msg .= 'Remote Host is not a valid domain name!';
                    return false;
                }
            define('remote_host', $remote_host);

            $port = $arr['port'];
            if (($port === '')||($port === null))
                {
                    $port = 587;
                }
            $port = "" . $port . "";
            $port = preg_replace('/^\s*|\s*$/', '', $port);
            if (!preg_match('/\d{2,4}/', $port))
                {
                    $Error_msg = 'Error: Port field is not valid. Mail was not sent.';
                    return false;
                }
            define('port', $port);
    

            $MAIL_FROM = $arr['MAIL_FROM'];
            $MAIL_FROM = "" . $MAIL_FROM . "";
            $MAIL_FROM = preg_replace('/^\s*|\s*$/', '', $MAIL_FROM);
            if (!preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $MAIL_FROM)) 
                {
                    $Error_msg = 'Error: MAIL_FROM address is not valid. Mail was not sent.';
                    return false;
                }
            if ((strlen($MAIL_FROM) > 70)||(strlen($MAIL_FROM) == 0))
                {
                    $Error_msg = "The " . 'MAIL_FROM' . " field length is more than 70 characers or is zero. Mail not sent!"; 
                    return false;
                }

            if (count($arr['Recipients']) === 0)
                {
                    $Error_msg = 'Error: Recipients field has not been filled. Mail was not sent.';
                    return false;
                }
            else
                {
                    for ($j=0; $j<count($arr['Recipients']); ++$j)
                        {
                            $Recipient = $arr['Recipients'][$j];
                            $Recipient = "" . $Recipient . "";
                            if (!preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $Recipient)) 
                                {
                                    $Error_msg = "Error: One of the recipients' address is not valid. Mail was not sent.";
                                    return false;
                                }
                             else
                                {
                                    $Recipient = preg_replace('/^\s*|\s*$/', '', $Recipient);
                                    $arr['Recipients'][$j] = $Recipient;
                                }
                        }
                }

            $From = $arr['From'];
            $From = "" . $From . "";
            $From = preg_replace('/^\s*|\s*$/', '', $From);
            if (!preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $From)) 
                {
                    $Error_msg = 'Error: From address is not valid. Mail was not sent.';
                    return false;
                }
            define('From', $From);
            if ((strlen(From) <= 70)&&(strlen(From) > 0))
                {
                    $From = 'From: ' . From . '\n' ;
                }
            else
                {
                    $Error_msg = "The " . 'From' . " field length is more than 70 characers. Mail not sent!"; 
                    return false;
                }

            $To = $arr['To'];
            $To = "" . $To . "";
            $To = preg_replace('/^\s*|\s*$/', '', $To);
            if (!preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $To)) 
                {
                    $Error_msg = 'Error: To address is not valid. Mail was not sent.';
                    return false;
                }
            define('To', $To);
            $To = To;
            if ((strlen($To) <= 70)&&(strlen($To) > 0))
                {
                    $To = 'To: ' . $To . '\n' ;
                }
            else
                {
                    $Error_msg = "The " . 'To' . " field length is more than 70 characers. Mail not sent!"; 
                    return false;
                }

            $Cc = $arr['Cc'];
            $Cc = "" . $Cc . "";
            $Cc = preg_replace('/^\s*|\s*$/', '', $Cc);
            if (!preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $Cc)) 
                {
                    $Error_msg = 'Error: Cc address is not valid. Mail was not sent.';
                    return false;
                }
            if ((strlen($Cc) <= 70)&&(strlen($Cc) > 0))
                {
                    $Cc = 'Cc: ' . $Cc . '\n' ;
                }
            elseif(strlen($Cc) > 70)
                {
                    $Error_msg = "The " . 'Cc' . " field length is more than 70 characers. Mail not sent!";
                    return false;
                }
            else
                {
                    $Cc = '';
                }

            $Bcc = $arr['Bcc'];
            $Bcc = "" . $Bcc . "";
            $Bcc = preg_replace('/^\s*|\s*$/', '', $Bcc);
            if (!preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $Bcc)) 
                {
                    $Error_msg = 'Error: Bcc address is not valid. Mail was not sent.';
                    return false;
                }
            if ((strlen($Bcc) <= 70)&&(strlen($Bcc) > 0))
                {
                    $Bcc = 'Bcc: ' . $Bcc . '\n' ;
                }
            elseif(strlen($Bcc) > 70)
                {
                    $Error_msg = "The " . 'Bcc' . " field length is more than 70 characers. Mail not sent!";
                    return false;
                }
            else
                {
                    $Bcc = '';
                }

            $Subject = $arr['Subject'];
            $Subject = "" . $Subject . "";
            $Subject = preg_replace('/^\s*|\s*$/', '', $Subject);
            if (!preg_match("/^[\w \.\'\"\-]+$/", $Subject))
                {
                    $Error_msg = 'Error: Subject has unwanted characters or is empty. Mail was not sent.';
                    return false;
                }
            define('Subject', $Subject);
            if ((strlen($Subject) <= 70)&&(strlen($Subject) > 0))
                {
                    $Subject = 'Subject: ' . Subject . '\n' ;
                }
            else
                {
                    $Error_msg = "The " . 'Subject' . " field length is more than 70 characers. Mail not sent!"; 
                    return false;
                }

            $Body = $arr['Body'];
            if ($Body === null)
                {
                    $Error_msg = "The " . 'Body' . " field cannot be empty. Mail not sent!"; 
                    return false;
                }

            $proto   = getprotobyname('tcp');
            $ip = gethostbyname(remote_host);
            $SOCK = socket_create(AF_INET, SOCK_STREAM, $proto);
            if (preg_match("/:+:+:/", remote_host)) 
                {
                    $SOCK = socket_create(AF_INET6, SOCK_STREAM, $proto);
                    $ip = remote_host;
                }

            if ($SOCK !== false)
                {
                    if (!socket_connect($SOCK, $ip, $port))
                        {
                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                            error_close($SOCK);
                            socket_close($SOCK);
                            return FALSE;
                        }
                }

            $str0 = socket_read($SOCK, 200);
            if ($str0 == false)
                {
                    $Error_msg .= socket_strerror(socket_last_error($SOCK));
                    error_close($SOCK);
                    socket_close($SOCK);
                    return false;
                }
            if (!preg_match("/^\s*220/", $str0))
                {
                    $Error_msg = $err_msg;
                }

            $str;

            $he_pktLen = strlen('HELO\n');
            $he_bytes_wrttn = 0;
            while (($he_pktLen - $he_bytes_wrttn) > 0)
                {
                    $he_balance = $he_pktLen - $he_bytes_wrttn;
                    $remaining_he = substr('HELO\n', $he_bytes_wrttn, $he_balance);
                    $he_bytes_wrttnNew = socket_write($SOCK, $remaining_he);
                    if ($he_bytes_wrttn === false)
                        {
                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                    $he_bytes_wrttn = $he_bytes_wrttn + $he_bytes_wrttnNew;
                } 
            $str = socket_read($SOCK, 200); 
            if ($str === false)
                {
                    $Error_msg .= socket_strerror(socket_last_error($SOCK));
                    error_close($SOCK);
                    socket_close($SOCK);
                    return false;
                }
            if (!preg_match("/^\s*250/", $str))
                {
                    $Error_msg = $err_msg;
                }

            $MAIL_FROM = 'MAIL FROM: ' . $MAIL_FROM . '\n';  
            $mf_pktLen = strlen($MAIL_FROM);
            $mf_bytes_wrttn = 0;
            while (($mf_pktLen - $mf_bytes_wrttn) > 0)
                {
                    $mf_balance = $mf_pktLen - $mf_bytes_wrttn;
                    $remaining_mf = substr($MAIL_FROM, $mf_bytes_wrttn, $mf_balance);
                    $mf_bytes_wrttnNew = socket_write($SOCK, $remaining_mf);
                    if ($mf_bytes_wrttn === false)
                        {
                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                    $mf_bytes_wrttn = $mf_bytes_wrttn + $mf_bytes_wrttnNew;
                }
            $str = socket_read($SOCK, 200);
            if ($str === false)
                {
                    $Error_msg .= socket_strerror(socket_last_error($SOCK));
                    error_close($SOCK);
                    socket_close($SOCK);
                    return false;
                }
            if (!preg_match("/^\s*250/", $str))
                {
                    $Error_msg = $err_msg;  
                }

            for ($n=0; $n<count($arr['Recipients']); ++$n)
                {
                    if (preg_match("/.*[0-9a-zA-Z_\.-]{1,64}@[0-9a-zA-Z_-]{1,252}(\.[0-9a-zA-Z_\-]{2,4}){0,2}/", $arr['Recipients'][$n])) 
                        {
                            $RCPTTO = 'RCPT TO: ' . '<' . $arr['Recipients'][$n] . '>' . '\n'; 
                            $rc_pktLen = strlen($RCPTTO);
                            $rc_bytes_wrttn = 0;
                            while (($rc_pktLen - $rc_bytes_wrttn) > 0)
                                {
                                    $rc_balance = $rc_pktLen - $rc_bytes_wrttn;
                                    $remaining_rc = substr($RCPTTO, $rc_bytes_wrttn, $rc_balance);
                                    $rc_bytes_wrttnNew = socket_write($SOCK, $remaining_rc);
                                    if ($rc_bytes_wrttn === false)
                                        {
                                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                                            error_close($SOCK);
                                            socket_close($SOCK);
                                            return false;
                                        }
                                    $rc_bytes_wrttn = $rc_bytes_wrttn + $rc_bytes_wrttnNew;
                                }
                            $str = socket_read($SOCK, 200);
                            if ($str === false)
                                {
                                    $Error_msg .= socket_strerror(socket_last_error($SOCK));
                                    error_close($SOCK);
                                    socket_close($SOCK);
                                    return false;
                                }
                            if (!preg_match("/^\s*250/", $str))
                                {
                                    error_close($SOCK);
                                    socket_close($SOCK);
                                    return false;
                                }
                        }
                     else
                        {
                            $Error_msg = 'The Recipients field is absent!';
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                }

            #send data
            if ($Error_msg === null)
                {
                    $da_pktLen = strlen('DATA\n');
                    $da_bytes_wrttn = 0;
                    while (($da_pktLen - $da_bytes_wrttn) > 0)
                        {
                            $da_balance = $da_pktLen - $da_bytes_wrttn;
                            $remaining_da = substr('DATA\n', $da_bytes_wrttn, $da_balance);
                            $da_bytes_wrttnNew = socket_write($SOCK, $remaining_da);
                            if ($da_bytes_wrttn === false)
                                {
                                    $Error_msg .= socket_strerror(socket_last_error($SOCK));
                                    error_close($SOCK);
                                    socket_close($SOCK);
                                    return false;
                                }
                            $da_bytes_wrttn = $da_bytes_wrttn + $da_bytes_wrttnNew;
                        }
                    $str = socket_read($SOCK, 200);
                    if ($str === false)
                        {
                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                    if (!preg_match("/^\s*354/", $str))
                        {
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                }
             else
                {
                    $Error_msg = $err_msg;
                    error_close($SOCK);
                    socket_close($SOCK);
                    return false;
                }

            $time = localtime();
            $week = array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
            $mYear = array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
    
            $serverDateStr;
   
            $year = 1900 + $time[5];
            $hr = $time[2];
            $mn = $time[1];
            $sc = $time[0];
            if (strlen($hr) === 1)
                {
                    $hr = "0" . $hr;
                }
            if (strlen($mn) === 1)
                {
                    $mn = "0" . $mn;
                }
            if (strlen($sc) === 1)
                {
                    $sc = "0" . $sc;
                }
            $serverDateStr = $week[$time[6]] . ", " . $time[3] . " " . $mYear[$time[4]] . " " . $year . " " . $hr . ":" . $mn . ":" . $sc;
  
            $serverDateStr = $serverDateStr . ' -0000';

            $Date = 'Date: ' . $serverDateStr . '\n' ;
   
            $blank_line = '\n';

            $msgVal = $Body;
            $msgVal = preg_replace('/^ +/', '', $msgVal);   #remove leading space characters
            $arr = preg_split('/\r\n|\n/', $msgVal, null, PREG_SPLIT_NO_EMPTY); #split at new lines
            $str = ""; #final string
            foreach ($arr as $val)
               {#form the final string inserting \n
                    if (strlen($val) <= 70)
                        {
                            $str = $str. $val . '\n'; 
                        }
                    else
                       {#get up to 70 characters without last broken word, ending them with \n
                            while (strlen($val) >0)
                                {
                                    if (strlen($val) >= 70)
                                        {
                                            $str1 = substr($val, 0, 70); 
                                            $str2 = $str1;
                                            $str2 = preg_replace('/\s\S*$/', '', $str2); 

                                            $str = $str . $str2 . '\n';
                                            if (strlen($str1) == 70)
                                                {
                                                    $val = preg_replace("/$str2/", '', $val); 
                                                    $val = preg_replace('/^\s+/', '', $val); 
                                                }
                                        }
                                    else
                                        {
                                            break;
                                        }
                                }
                            $val = preg_replace('/^\s+/', '', $val);   #remove leading whitespace characters
                            $str = $str . $val . '\n';
                       }
                }
            $Body = $str;

            $DATA = $From . $To . $Cc . $Bcc . $Date . $Subject . $blank_line . $Body . '.\n';

            if ($Error_msg === null)
                {
                    $dt_pktLen = strlen($DATA);
                    $dt_bytes_wrttn = 0;
                    while (($dt_pktLen - $dt_bytes_wrttn) > 0)
                       {
                            $dt_balance = $dt_pktLen - $dt_bytes_wrttn;
                            $remaining_dt = substr($DATA, $dt_bytes_wrttn, $dt_balance);
                            $dt_bytes_wrttnNew = socket_write($SOCK, $remaining_dt);
                            if ($dt_bytes_wrttn === false)
                                {
                                   $Error_msg .= socket_strerror(socket_last_error($SOCK));
                                   error_close($SOCK);
                                   socket_close($SOCK);
                                   return false;
                                }
                            $dt_bytes_wrttn = $dt_bytes_wrttn + $dt_bytes_wrttnNew;
                       }
                    $str = socket_read($SOCK, 200);
                    if ($str === false)
                        {
                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                    if (!preg_match("/^\s*250/", $str))
                        {
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                }

            $qu_pktLen = strlen('QUIT\n');
            $qu_bytes_wrttn = 0;
            while (($qu_pktLen - $qu_bytes_wrttn) > 0)
               {
                    $qu_balance = $qu_pktLen - $qu_bytes_wrttn;
                    $remaining_qu = substr('QUIT\n', $qu_bytes_wrttn, $qu_balance);
                    $qu_bytes_wrttnNew = socket_write($SOCK, $remaining_qu);
                    if ($qu_bytes_wrttn === false)
                        {
                            $Error_msg .= socket_strerror(socket_last_error($SOCK));
                            error_close($SOCK);
                            socket_close($SOCK);
                            return false;
                        }
                    $qu_bytes_wrttn = $qu_bytes_wrttn + $qu_bytes_wrttnNew;
               }

            return true;

        }


?>